package com.barchart.util.value.provider;

import com.barchart.util.loader.Producer;
import com.barchart.util.value.api.Factory;

/**
 * Static service provider.
 * <p>
 * This class is excluded from api at build time and must be available from the
 * provider at run time.
 */
public class FactoryProvider implements Producer<Factory> {

	/**
	 * Load a {@link Factory}.
	 */
	@Override
	public Factory produce() {
		throw new IllegalStateException("Build-time failure.");
	}

}
